package com.gic.evaluate.dto;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 10:34
 */
public class ProblemDTO implements Serializable {
    private static final long serialVersionUID = -7669213242276410474L;

    /**
     * 投诉与建议id
     */
    private Integer problemId;

    /**
     * 商户id
     */
    private Integer enterpriseId;

    /**
     * 门店id
     */
    private Integer storeId;

    /**
     * 门店名称
     */
    private String storeName;

    /**
     * 会员mcuId
     */
    private Long memberId;

    /**
     * 会员acuId
     */
    private Long acuId;

    /**
     * 会员ecuId
     */
    private Long ecuId;

    private Long areaId;
    private String unionId;
    /**
     * 会员名
     */
    private String memberName;

    /**
     * 会员手机
     */
    private String memberPhone;

    /**
     * 会员头像
     */
    private String memberImgUrl;
    /**
     * 评论内容
     */
    private String problemContent;

    /**
     * 冗余的评论首图
     */
    private String imageUrl;

    /**
     * 是否有其他图片
     */
    private Integer hasOtherImage;

    /**
     * 0:待处理  1:已回复  2：有更新
     */
    private Integer problemStatus;

    /**
     * 是否是恶意评论
     */
    private Integer maliciousStatus;

    /**
     * 标记被恶意评价的时间
     */
    private Date maliciousStatusTime;

    /**
     * 是否展示
     */
    private Integer showStatus;

    /**
     *
     */
    private Integer status;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;

    // 管理员第一次回复内容
    private String replyContent;
    // 回复数量
    private Integer problemCount;
    // 图片
    private List<String> imgList;

    // 回复列表
    private List<ProblemReplyDTO> replyList;
    private String replyUserContent;

    public Integer getProblemId() {
        return problemId;
    }

    public void setProblemId(Integer problemId) {
        this.problemId = problemId;
    }

    public Integer getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(Integer enterpriseId) {
        this.enterpriseId = enterpriseId;
    }

    public Integer getStoreId() {
        return storeId;
    }

    public void setStoreId(Integer storeId) {
        this.storeId = storeId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public Long getMemberId() {
        return memberId;
    }

    public void setMemberId(Long memberId) {
        this.memberId = memberId;
    }

    public Long getAcuId() {
        return acuId;
    }

    public void setAcuId(Long acuId) {
        this.acuId = acuId;
    }

    public Long getEcuId() {
        return ecuId;
    }

    public void setEcuId(Long ecuId) {
        this.ecuId = ecuId;
    }

    public String getMemberName() {
        return memberName;
    }

    public void setMemberName(String memberName) {
        this.memberName = memberName;
    }

    public String getMemberPhone() {
        return memberPhone;
    }

    public void setMemberPhone(String memberPhone) {
        this.memberPhone = memberPhone;
    }

    public String getMemberImgUrl() {
        return memberImgUrl;
    }

    public void setMemberImgUrl(String memberImgUrl) {
        this.memberImgUrl = memberImgUrl;
    }

    public String getProblemContent() {
        return problemContent;
    }

    public void setProblemContent(String problemContent) {
        this.problemContent = problemContent;
    }

    public String getImageUrl() {
        return imageUrl;
    }

    public void setImageUrl(String imageUrl) {
        this.imageUrl = imageUrl;
    }

    public Integer getHasOtherImage() {
        return hasOtherImage;
    }

    public void setHasOtherImage(Integer hasOtherImage) {
        this.hasOtherImage = hasOtherImage;
    }

    public Integer getProblemStatus() {
        return problemStatus;
    }

    public void setProblemStatus(Integer problemStatus) {
        this.problemStatus = problemStatus;
    }

    public Integer getMaliciousStatus() {
        return maliciousStatus;
    }

    public void setMaliciousStatus(Integer maliciousStatus) {
        this.maliciousStatus = maliciousStatus;
    }

    public Integer getShowStatus() {
        return showStatus;
    }

    public void setShowStatus(Integer showStatus) {
        this.showStatus = showStatus;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getReplyContent() {
        return replyContent;
    }

    public void setReplyContent(String replyContent) {
        this.replyContent = replyContent;
    }

    public Integer getProblemCount() {
        return problemCount;
    }

    public void setProblemCount(Integer problemCount) {
        this.problemCount = problemCount;
    }

    public List<String> getImgList() {
        return imgList;
    }

    public void setImgList(List<String> imgList) {
        this.imgList = imgList;
    }

    public List<ProblemReplyDTO> getReplyList() {
        return replyList;
    }

    public void setReplyList(List<ProblemReplyDTO> replyList) {
        this.replyList = replyList;
    }

    public String getReplyUserContent() {
        return replyUserContent;
    }

    public void setReplyUserContent(String replyUserContent) {
        this.replyUserContent = replyUserContent;
    }

    public Date getMaliciousStatusTime() {
        return maliciousStatusTime;
    }

    public void setMaliciousStatusTime(Date maliciousStatusTime) {
        this.maliciousStatusTime = maliciousStatusTime;
    }

    public Long getAreaId() {
        return areaId;
    }

    public void setAreaId(Long areaId) {
        this.areaId = areaId;
    }

    public String getUnionId() {
        return unionId;
    }

    public void setUnionId(String unionId) {
        this.unionId = unionId;
    }
}