package com.gic.evaluate.service;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.evaluate.dto.BadEvaluateConfigDTO;
import com.gic.evaluate.dto.EvaluateOrderConfigDTO;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-25 17:18
 */
public interface EvaluateConfigApiService {

    /**
     * 初始化评价配置
     * @Title: init
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> init(Integer enterpriseId);

    /**
     * 修改订单评价机制/修改投诉处理机制
     * @Title: updateOrderConfig
     * @Description:
     * @author zhiwj
     * @param evaluateOrderConfigDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> updateEvaluateOrderConfig(EvaluateOrderConfigDTO evaluateOrderConfigDTO);

    /**
     * 修改不良评价回访机制
     * @Title: updateBadEvaluateConfig
     * @Description:
     * @author zhiwj
     * @param badEvaluateConfigDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> updateBadEvaluateConfig(BadEvaluateConfigDTO badEvaluateConfigDTO);

    /**
     * 查询商户对应的订单评价机制/修改投诉处理机制
     * @Title: getOrderConfig
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.api.base.commons.ServiceResponse<com.gic.auth.dto.EvaluateOrderConfigDTO>
     * @throws
     */
    ServiceResponse<EvaluateOrderConfigDTO> getEvaluateOrderConfig(Integer enterpriseId);

    /**
     * 查询商户对应的不良评价机制
     * @Title: getBadEvaluateConfig
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.api.base.commons.ServiceResponse<com.gic.auth.dto.BadEvaluateConfigDTO>
     * @throws
     */
    ServiceResponse<BadEvaluateConfigDTO> getBadEvaluateConfig(Integer enterpriseId);


    /**
     * 保存
     * @Title: updateEvaluateMind
     * @Description: 保存
     * @author zhiwj
     * @param enterpriseId
     * @param mind
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
    ServiceResponse<Void> updateEvaluateMind(Integer enterpriseId, Integer mind);

    /**
     * 查询评价
     * @Title: getEvaluateMind
     * @Description: 查询评价
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
    ServiceResponse<Integer> getEvaluateMind(Integer enterpriseId);
}
