package com.gic.evaluate.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.evaluate.qo.StoreScoreQO;
import com.gic.evaluate.qo.StoreTrendQO;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-27 15:51
 */
public interface EvaluateOverviewApiService {

    /**
     * 图表1  近期评价总数
     * @Title: chart1
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return com.gic.api.base.commons.ServiceResponse<java.util.Map<java.lang.String,java.lang.Long>>
     * @throws
     */
    ServiceResponse<Map<String, Long>> chart1(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * 图表2 各项评分概况
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return
     */
    ServiceResponse<HashMap<String, Map<String, Long>>> chart2(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * 图表3 评价趋势
     * @Title: chart3
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return com.gic.api.base.commons.ServiceResponse<java.util.Map<java.lang.String,java.util.List<java.util.Map<java.lang.String,java.lang.Object>>>>
     * @throws
     */
    ServiceResponse<Map<String, List<Map<String, Object>>>> chart3(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * 图表4 正面/负面快评使用统计 变化趋势
     * @Title: chart4
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return com.gic.api.base.commons.ServiceResponse<java.util.Map<java.lang.String,java.util.List<java.util.Map<java.lang.String,java.lang.Object>>>>
     * @throws
     */
    ServiceResponse<Map<String, List<Map<String, Object>>>> chart4(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * 查询门店评分
     * @Title: listStoreScore
     * @Description:
     * @author zhiwj
     * @param storeScoreQO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Page<Map<String, Object>>> listStoreScore(StoreScoreQO storeScoreQO);

    /**
     * 门店总评分
     * @Title: getTotalStoreScore
     * @Description:
     * @author zhiwj
     * @param storeScoreQO
     * @return com.gic.api.base.commons.ServiceResponse<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    ServiceResponse<Map<String, Object>> getTotalStoreScore(StoreScoreQO storeScoreQO);

    /**
     * 查询趋势详情
     * @Title: listTrend
     * @Description:
     * @author zhiwj
     * @param storeTrendQO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Page<Map<String, Object>>> listTrend(StoreTrendQO storeTrendQO);

    /**
     * 查看各个时间段好评的变化趋势
     * @Title: listGoodEvaluateTrendByDate
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return com.gic.api.base.commons.ServiceResponse<java.util.List<java.util.Map<java.lang.String,java.lang.Integer>>>
     * @throws
     */
    ServiceResponse<List<Map<String, Integer>>> listGoodEvaluateTrendByDate(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * 查看各个时间段差评的变化趋势
     * @Title: listBadEvaluateTrendByDate
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return com.gic.api.base.commons.ServiceResponse<java.util.List<java.util.Map<java.lang.String,java.lang.Integer>>>
     * @throws
     */
    ServiceResponse<List<Map<String, Integer>>> listBadEvaluateTrendByDate(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);
}
