package com.gic.evaluate.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.dto.ProblemUserReplyDTO;
import com.gic.evaluate.qo.ProblemQO;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 10:32
 */
public interface ProblemManageApiService {

    /**
     * 查询列表
     * @Title: listProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Page<ProblemDTO>> listProblem(ProblemQO problemQO);

    /**
     * 求个数
     * @Title: countProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Integer>
     * @throws
     */
    ServiceResponse<Integer> countProblem(ProblemQO problemQO);

    /**
     * 查详情
     * @Title: getProblem
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<ProblemDTO> getProblem(Integer problemId);

    /**
     * 回复
     * @Title: replyProblem
     * @Description:
     * @author zhiwj
     * @param problemUserReplyDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> replyProblem(ProblemUserReplyDTO problemUserReplyDTO);

    /**
     * 回复
     * @Title: replyProblem
     * @Description:
     * @author zhiwj
     * @param problemIdList
     * @param problemUserReplyDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> replyProblem(List<Integer> problemIdList, ProblemUserReplyDTO problemUserReplyDTO);

    /**
     * 更新恶评
     * @Title: updateMaliciousStatus
     * @Description:
     * @author zhiwj
     * @param problemId
     * @param maliciousStatus
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> updateMaliciousStatus(Integer problemId, Integer maliciousStatus);

    /**
     * 删除回复
     * @Title: deleteReply
     * @Description:
     * @author zhiwj
     * @param problemReplyId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> deleteReply(Integer problemReplyId);

    /**
     * 编辑
     * @Title: editReplyProblem
     * @Description:
     * @author zhiwj
     * @param problemUserReplyDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> editReplyProblem(ProblemUserReplyDTO problemUserReplyDTO);
}
