package com.gic.evaluate.service;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.dto.ProblemMemberReplyDTO;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 10:31
 */
public interface ProblemOutApiService {

    /**
     * 保存投诉
     * @Title: saveProblem
     * @Description:
     * @author zhiwj
     * @param problemDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> saveProblem(ProblemDTO problemDTO);

    /**
     * 保存回复
     * @Title: saveProblem
     * @Description:
     * @author zhiwj
     * @param problemMemberReplyDTO
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> saveProblemReply(ProblemMemberReplyDTO problemMemberReplyDTO);

    /**
     * 投诉与建议 列表
     * @Title: listProblem
     * @Description:
     * @author zhiwj
     * @param acuId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<List<ProblemDTO>> listProblem(Long acuId);

    /**
     * 投诉与建议 详情
     * @Title: getProblem
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<ProblemDTO> getProblem(Integer problemId);

    /**
     * 结束回复
     * @Title: endProblem
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Void>
     * @throws
     */
    ServiceResponse<Void> endProblem(Integer problemId);

    /**
     * 判断会员能不能进行投诉
     * @Title: ensure
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param acuId
     * @return com.gic.api.base.commons.ServiceResponse<java.lang.Boolean>
     * @throws
     */
    ServiceResponse<Void> ensure(Integer enterpriseId, Long acuId);
}
