package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabBadEvaluateConfig;

/**
 * 
 * @ClassName: TabBadEvaluateConfigMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 18:50
 */
public interface TabBadEvaluateConfigMapper {
    /**
     * 根据主键删除
     *
     * @param badEvaluateConfigId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer badEvaluateConfigId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabBadEvaluateConfig record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabBadEvaluateConfig record);

    /**
     * 根据主键查询
     *
     * @param badEvaluateConfigId 主键
     * @return 实体对象
     */
    TabBadEvaluateConfig selectByPrimaryKey(Integer badEvaluateConfigId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabBadEvaluateConfig record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabBadEvaluateConfig record);

    /**
     * 查询配置
     * @Title: getBadEvaluateConfig
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return com.gic.evaluate.entity.TabBadEvaluateConfig
     * @throws
     */
    TabBadEvaluateConfig getBadEvaluateConfig(Integer enterpriseId);
}