package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluateImg;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 
 * @ClassName: TabEvaluateImgMapper
 * @Description:
 * @author zhiwj
 * @date 2020-09-08 18:50
 */
public interface TabEvaluateImgMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateImgId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer evaluateImgId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluateImg record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluateImg record);

    /**
     * 根据主键查询
     *
     * @param evaluateImgId 主键
     * @return 实体对象
     */
    TabEvaluateImg selectByPrimaryKey(Integer evaluateImgId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluateImg record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluateImg record);

    /**
     * listImageByEvaluateId
     * @Title: listImageByEvaluateId
     * @Description:
     * @author zhiwj
     * @param evaluateId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateImg>
     * @throws
     */
    List<TabEvaluateImg> listImageByEvaluateId(@Param("evaluateId") Integer evaluateId);

    /**
     * listImageByEvaluateReplyId
     * @Title: listImageByEvaluateReplyId
     * @Description:
     * @author zhiwj
     * @param evaluateReplyId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateImg>
     * @throws
     */
    List<TabEvaluateImg> listImageByEvaluateReplyId(@Param("evaluateReplyId") Integer evaluateReplyId);

}