package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluateMsgLog;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 
 * @ClassName: TabEvaluateMsgLogMapper
 * @Description:
 * @author zhiwj
 * @date 2020-09-08 18:50
 */
public interface TabEvaluateMsgLogMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateMsgLogId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Long evaluateMsgLogId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluateMsgLog record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluateMsgLog record);

    /**
     * 根据主键查询
     *
     * @param evaluateMsgLogId 主键
     * @return 实体对象
     */
    TabEvaluateMsgLog selectByPrimaryKey(Long evaluateMsgLogId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluateMsgLog record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluateMsgLog record);

    /**
     * getByOrderId
     * @Title: getByOrderId
     * @Description:
     * @author zhiwj
     * @param orderId
     * @return com.gic.evaluate.entity.TabEvaluateMsgLog
     * @throws
     */
    TabEvaluateMsgLog getByOrderId(Long orderId);

    /**
     * listFirstMsgLogs
     * @Title: listFirstMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTimeOfDay
     * @param endTimeOfDay
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listFirstMsgLogs(@Param("enterpriseId") Integer enterpriseId, @Param("startTimeOfDay") Date startTimeOfDay, @Param("endTimeOfDay") Date endTimeOfDay);

    /**
     * listSecondMsgLogs
     * @Title: listSecondMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTimeOfDay
     * @param endTimeOfDay
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listSecondMsgLogs(@Param("enterpriseId") Integer enterpriseId, @Param("startTimeOfDay") Date startTimeOfDay, @Param("endTimeOfDay") Date endTimeOfDay);

    /**
     * listReviewMsgLogs
     * @Title: listReviewMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTimeOfDay
     * @param endTimeOfDay
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listReviewMsgLogs(@Param("enterpriseId") Integer enterpriseId, @Param("startTimeOfDay") Date startTimeOfDay, @Param("endTimeOfDay") Date endTimeOfDay);

    /**
     * orderCountByStoreId
     * @Title: orderCountByStoreId
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param storeIdList
     * @return java.util.Map<java.lang.Integer,java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    @MapKey("storeId")
    Map<Integer,Map<String,Object>> orderCountByStoreId(@Param("enterpriseId") Integer enterpriseId, @Param("ids") List<Integer> storeIdList);

    /**
     * listTrendOrderCount
     * @Title: listTrendOrderCount
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listTrendOrderCount(@Param("enterpriseId") Integer enterpriseId, @Param("startTime") String startTime, @Param("endTime") String endTime, @Param("ids") List<Integer> storeIdList);
}