package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluateReply;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 
 * @ClassName: TabEvaluateReplyMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 18:58
 */
public interface TabEvaluateReplyMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateReplyId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer evaluateReplyId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluateReply record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluateReply record);

    /**
     * 根据主键查询
     *
     * @param evaluateReplyId 主键
     * @return 实体对象
     */
    TabEvaluateReply selectByPrimaryKey(Integer evaluateReplyId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluateReply record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluateReply record);

    /**
     * listEvaluateReply
     * @Title: listEvaluateReply
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param showStatus
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateReply>
     * @throws
     */
    List<TabEvaluateReply> listEvaluateReply(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") Integer evaluateId, @Param("showStatus") Integer showStatus);

    /**
     * updateReplyShowStatus
     * @Title: updateReplyShowStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateReplyId
     * @param showStatus
     * @return void
     * @throws
     */
    void updateReplyShowStatus(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateReplyId") Integer evaluateReplyId, @Param("showStatus") Integer showStatus);

    /**
     * countReviewReplyByMember
     * @Title: countReviewReplyByMember
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @return java.lang.Integer
     * @throws
     */
    Integer countReviewReplyByMember(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") Integer evaluateId);
}