package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluateTags;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 
 * @ClassName: TabEvaluateTagsMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 19:01
 */
public interface TabEvaluateTagsMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateTagsId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer evaluateTagsId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluateTags record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluateTags record);

    /**
     * 根据主键查询
     *
     * @param evaluateTagsId 主键
     * @return 实体对象
     */
    TabEvaluateTags selectByPrimaryKey(Integer evaluateTagsId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluateTags record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluateTags record);

    /**
     * listEvaluateTags
     * @Title: listEvaluateTags
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param evaluateReplyId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateTags>
     * @throws
     */
    List<TabEvaluateTags> listEvaluateTags(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateId") Integer evaluateId, @Param("evaluateReplyId") Integer evaluateReplyId);
}