package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabProblemImg;

import java.util.List;

/**
 * 
 * @ClassName: TabProblemImgMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 18:58
 */
public interface TabProblemImgMapper {
    /**
     * 根据主键删除
     *
     * @param problemImgId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer problemImgId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabProblemImg record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabProblemImg record);

    /**
     * 根据主键查询
     *
     * @param problemImgId 主键
     * @return 实体对象
     */
    TabProblemImg selectByPrimaryKey(Integer problemImgId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabProblemImg record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabProblemImg record);

    /**
     * listImageByProblemId
     * @Title: listImageByProblemId
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return java.util.List<com.gic.evaluate.entity.TabProblemImg>
     * @throws
     */
    List<TabProblemImg> listImageByProblemId(Integer problemId);

    /**
     * listImageByProblemReplyId
     * @Title: listImageByProblemReplyId
     * @Description:
     * @author zhiwj
     * @param problemReplyId
     * @return java.util.List<com.gic.evaluate.entity.TabProblemImg>
     * @throws
     */
    List<TabProblemImg> listImageByProblemReplyId(Integer problemReplyId);
}