package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.entity.TabProblem;
import com.gic.evaluate.qo.ProblemQO;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * 
 * @ClassName: TabProblemMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 19:05
 */
public interface TabProblemMapper {
    /**
     * 根据主键删除
     *
     * @param problemId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer problemId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabProblem record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabProblem record);

    /**
     * 根据主键查询
     *
     * @param problemId 主键
     * @return 实体对象
     */
    TabProblem selectByPrimaryKey(Integer problemId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabProblem record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabProblem record);

    /**
     * listProblem
     * @Title: listProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return com.github.pagehelper.Page<com.gic.evaluate.entity.TabProblem>
     * @throws
     */
    Page<TabProblem> listProblem(ProblemQO problemQO);

    /**
     * countProblem
     * @Title: countProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return java.lang.Integer
     * @throws
     */
    Integer countProblem(ProblemQO problemQO);

    /**
     * listProblemByAcuId
     * @Title: listProblemByAcuId
     * @Description:
     * @author zhiwj
     * @param acuId
     * @return java.util.List<com.gic.evaluate.dto.ProblemDTO>
     * @throws
     */
    List<ProblemDTO> listProblemByAcuId(@Param("acuId") Long acuId);

    /**
     * 查询会员在某个时间段之后 有没有恶意评价
     * @param acuId
     * @param date
     * @return
     */
    TabProblem getMaliciousStatusByAcuIdBeforeHours(@Param("acuId") Long acuId, @Param("date") Date date);
}