package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabProblemReply;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 
 * @ClassName: TabProblemReplyMapper
 * @Description:  
 * @author zhiwj
 * @date 2020-09-08 18:50
 */
public interface TabProblemReplyMapper {
    /**
     * 根据主键删除
     *
     * @param problemReplyId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer problemReplyId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabProblemReply record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabProblemReply record);

    /**
     * 根据主键查询
     *
     * @param problemReplyId 主键
     * @return 实体对象
     */
    TabProblemReply selectByPrimaryKey(Integer problemReplyId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabProblemReply record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabProblemReply record);

    /**
     * listReply
     * @Title: listReply
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return java.util.List<com.gic.evaluate.entity.TabProblemReply>
     * @throws
     */
    List<TabProblemReply> listReply(Integer problemId);

    /**
     * firstReplyByProblemId
     * @Title: firstReplyByProblemId
     * @Description:
     * @author zhiwj
     * @param problemIdList
     * @return java.util.List<com.gic.evaluate.entity.TabProblemReply>
     * @throws
     */
    List<TabProblemReply> firstReplyByProblemId(@Param("ids") List<Integer> problemIdList);
}