package com.gic.evaluate.service;

import com.gic.evaluate.entity.TabEvaluateMsgLog;

import java.util.List;
import java.util.Map;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2020/2/6 13:41
 */
public interface EvaluateMsgLogService {
    /**
     * save
     * @Title: save
     * @Description:
     * @author zhiwj
     * @param evaluateMsgLog
     * @return void
     * @throws
     */
    void save(TabEvaluateMsgLog evaluateMsgLog);

    /**
     * getByOrderId
     * @Title: getByOrderId
     * @Description:
     * @author zhiwj
     * @param orderId
     * @return com.gic.evaluate.entity.TabEvaluateMsgLog
     * @throws
     */
    TabEvaluateMsgLog getByOrderId(Long orderId);

    /**
     * listFirstMsgLogs
     * @Title: listFirstMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listFirstMsgLogs(Integer enterpriseId);

    /**
     * listSecondMsgLogs
     * @Title: listSecondMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listSecondMsgLogs(Integer enterpriseId);

    /**
     * listReviewMsgLogs
     * @Title: listReviewMsgLogs
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateMsgLog>
     * @throws
     */
    List<TabEvaluateMsgLog> listReviewMsgLogs(Integer enterpriseId);

    /**
     * update
     * @Title: update
     * @Description:
     * @author zhiwj
     * @param log
     * @return void
     * @throws
     */
    void update(TabEvaluateMsgLog log);

    /**
     * orderCountByStoreId
     * @Title: orderCountByStoreId
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param storeIdList
     * @return java.util.Map<java.lang.Integer,java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    Map<Integer,Map<String,Object>> orderCountByStoreId(Integer enterpriseId, List<Integer> storeIdList);

    /**
     * listTrendOrderCount
     * @Title: listTrendOrderCount
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listTrendOrderCount(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);
}
