package com.gic.evaluate.service;

import com.gic.evaluate.dto.MemberReplyDTO;
import com.gic.evaluate.dto.UserReplyDTO;
import com.gic.evaluate.entity.TabEvaluateReply;

import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-27 9:52
 */
public interface EvaluateReplyService {

    /**
     * listEvaluateReply
     * @Title: listEvaluateReply
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param showStatus
     * @return java.util.List<com.gic.evaluate.entity.TabEvaluateReply>
     * @throws
     */
    List<TabEvaluateReply> listEvaluateReply(Integer enterpriseId, Integer evaluateId, Integer showStatus);

    /**
     * countReviewReplyByMember
     * @Title: countReviewReplyByMember
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @return java.lang.Integer
     * @throws
     */
    Integer countReviewReplyByMember(Integer enterpriseId, Integer evaluateId);

    /**
     * saveUserReplyEvaluate
     * @Title: saveUserReplyEvaluate
     * @Description:
     * @author zhiwj
     * @param userReplyDTO
     * @return java.lang.Integer
     * @throws
     */
    Integer saveUserReplyEvaluate(UserReplyDTO userReplyDTO);

    /**
     * saveMemberReplyEvaluate
     * @Title: saveMemberReplyEvaluate
     * @Description:
     * @author zhiwj
     * @param memberReplyDTO
     * @return java.lang.Integer
     * @throws
     */
    Integer saveMemberReplyEvaluate(MemberReplyDTO memberReplyDTO);

    /**
     * delReply
     * @Title: delReply
     * @Description:
     * @author zhiwj
     * @param evaluateReplyId
     * @return void
     * @throws
     */
    void delReply(Integer evaluateReplyId);

    /**
     * updateReplyShowStatus
     * @Title: updateReplyShowStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateReplyId
     * @param showStatus
     * @return void
     * @throws
     */
    void updateReplyShowStatus(Integer enterpriseId, Integer evaluateReplyId, Integer showStatus);

    /**
     * update
     * @Title: update
     * @Description:
     * @author zhiwj
     * @param userReplyDTO
     * @return void
     * @throws
     */
    void update(UserReplyDTO userReplyDTO);
}
