package com.gic.evaluate.service;

import com.gic.evaluate.dto.EvaluateDTO;
import com.gic.evaluate.entity.TabEvaluate;
import com.gic.evaluate.qo.EvaluateQO;
import com.gic.evaluate.qo.StoreScoreQO;
import com.gic.evaluate.qo.StoreTrendQO;
import com.github.pagehelper.Page;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-27 9:51
 */
public interface EvaluateService {
    /**
     * listEvaluate
     * @Title: listEvaluate
     * @Description:
     * @author zhiwj
     * @param evaluateQO
     * @return com.github.pagehelper.Page<com.gic.evaluate.entity.TabEvaluate>
     * @throws
     */
    Page<TabEvaluate> listEvaluate(EvaluateQO evaluateQO);

    /**
     * listEvaluateNearByStore
     * @Title: listEvaluateNearByStore
     * @Description:
     * @author zhiwj
     * @param evaluateQO
     * @return com.github.pagehelper.Page<com.gic.evaluate.entity.TabEvaluate>
     * @throws
     */
    Page<TabEvaluate> listEvaluateNearByStore(EvaluateQO evaluateQO);

    /**
     * countEvaluate
     * @Title: countEvaluate
     * @Description:
     * @author zhiwj
     * @param evaluateQO
     * @return java.lang.Integer
     * @throws
     */
    Integer countEvaluate(EvaluateQO evaluateQO);

    /**
     * getEvaluate
     * @Title: getEvaluate
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @return com.gic.evaluate.entity.TabEvaluate
     * @throws
     */
    TabEvaluate getEvaluate(Integer enterpriseId, Integer evaluateId);

    /**
     * saveEvaluate
     * @Title: saveEvaluate
     * @Description:
     * @author zhiwj
     * @param evaluateDTO
     * @return java.lang.Integer
     * @throws
     */
    Integer saveEvaluate(EvaluateDTO evaluateDTO);

    /**
     * updateShowStatus
     * @Title: updateShowStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param showStatus
     * @return void
     * @throws
     */
    void updateShowStatus(Integer enterpriseId, List<Integer> evaluateId, Integer showStatus);

    /**
     * updateTopHotStatus
     * @Title: updateTopHotStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param topHotStatus
     * @return void
     * @throws
     */
    void updateTopHotStatus(Integer enterpriseId, Integer evaluateId, Integer topHotStatus);

    /**
     * updateMaliciousStatus
     * @Title: updateMaliciousStatus
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param evaluateId
     * @param maliciousStatus
     * @return void
     * @throws
     */
    void updateMaliciousStatus(Integer enterpriseId, Integer evaluateId, Integer maliciousStatus);

    /**
     * getTotalCountChart
     * @Title: getTotalCountChart
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.Map<java.lang.String,java.lang.Long>
     * @throws
     */
    Map<String, Long> getTotalCountChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * getGoodsCountChart
     * @Title: getGoodsCountChart
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.Map<java.lang.String,java.lang.Long>
     * @throws
     */
    Map<String, Long> getGoodsCountChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * getStoreCountChart
     * @Title: getStoreCountChart
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.Map<java.lang.String,java.lang.Long>
     * @throws
     */
    Map<String, Long> getStoreCountChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * getServiceCountChart
     * @Title: getServiceCountChart
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.Map<java.lang.String,java.lang.Long>
     * @throws
     */
    Map<String, Long> getServiceCountChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * listTrendTotalEvaluate
     * @Title: listTrendTotalEvaluate
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listTrendTotalEvaluate(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * listTrendGoodEvaluate
     * @Title: listTrendGoodEvaluate
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listTrendGoodEvaluate(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList);

    /**
     * listStoreScore
     * @Title: listStoreScore
     * @Description:
     * @author zhiwj
     * @param storeScoreQO
     * @return com.github.pagehelper.Page<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    Page<Map<String, Object>> listStoreScore(StoreScoreQO storeScoreQO);

    /**
     * getTotalStoreScore
     * @Title: getTotalStoreScore
     * @Description:
     * @author zhiwj
     * @param storeScoreQO
     * @return java.util.Map<java.lang.String,java.lang.Object>
     * @throws
     */
    Map<String, Object> getTotalStoreScore(StoreScoreQO storeScoreQO);

    /**
     * listTrend
     * @Title: listTrend
     * @Description:
     * @author zhiwj
     * @param storeTrendQO
     * @return com.github.pagehelper.Page<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    Page<Map<String, Object>> listTrend(StoreTrendQO storeTrendQO);

    /**
     * getEvaluateByOrderId
     * @Title: getEvaluateByOrderId
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param orderId
     * @return com.gic.evaluate.entity.TabEvaluate
     * @throws
     */
    TabEvaluate getEvaluateByOrderId(Integer enterpriseId, Long orderId);

    /**
     * updateEvaluate
     * @Title: updateEvaluate
     * @Description:
     * @author zhiwj
     * @param evaluateDTO
     * @return void
     * @throws
     */
    void updateEvaluate(EvaluateDTO evaluateDTO);

    /**
     * listEvaluateTrendByYear
     * @Title: listEvaluateTrendByYear
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param replyType
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listEvaluateTrendByYear(Integer enterpriseId, Integer replyType);

    /**
     * listEvaluateTrendByMonth
     * @Title: listEvaluateTrendByMonth
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param replyType
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listEvaluateTrendByMonth(Integer enterpriseId, Integer replyType);

    /**
     * listEvaluateTrendByDay
     * @Title: listEvaluateTrendByDay
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param replyType
     * @return java.util.List<java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    List<Map<String, Object>> listEvaluateTrendByDay(Integer enterpriseId, Integer replyType);

    /**
     * getStoreTopHot
     * @Title: getStoreTopHot
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param storeId
     * @return java.lang.Integer
     * @throws
     */
    Integer getStoreTopHot(Integer enterpriseId, Integer storeId);

    /**
     * listAllEvaluateId
     * @Title: listAllEvaluateId
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @return java.util.List<java.lang.Integer>
     * @throws
     */
    List<Integer> listAllEvaluateId(Integer enterpriseId);

    /**
     * getStoreIdHasTopHot
     * @Title: getStoreIdHasTopHot
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param storeIdList
     * @return java.util.Set<java.lang.Integer>
     * @throws
     */
    Set<Integer> getStoreIdHasTopHot(Integer enterpriseId, List<Integer> storeIdList);

    /**
     * countEvaluateTrend
     * @Title: countEvaluateTrend
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param startTime
     * @param endTime
     * @param storeIdList
     * @param quickReplyTypeEnumCode
     * @return java.lang.Integer
     * @throws
     */
    Integer countEvaluateTrend(Integer enterpriseId, Date startTime, Date endTime , List<Integer> storeIdList, Integer quickReplyTypeEnumCode);

    /**
     * hasMaliciousStatusBeforeHours
     * @Title: hasMaliciousStatusBeforeHours
     * @Description:
     * @author zhiwj
     * @param evaluateId
     * @param badEvaluateTagType
     * @return boolean
     * @throws
     */
    boolean hasMaliciousStatusBeforeHours(Integer evaluateId, Integer badEvaluateTagType);

    /**
     * queryEvaluateCountByStoreId
     * @Title: queryEvaluateCountByStoreId
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param storeIdList
     * @return java.util.Map<java.lang.Integer,java.util.Map<java.lang.String,java.lang.Object>>
     * @throws
     */
    Map<Integer,Map<String,Object>> queryEvaluateCountByStoreId(Integer enterpriseId, List<Integer> storeIdList);

    /**
     * getEvaluateByOrderNumber
     * @Title: getEvaluateByOrderNumber
     * @Description:
     * @author zhiwj
     * @param enterpriseId
     * @param orderNumber
     * @return com.gic.evaluate.entity.TabEvaluate
     * @throws
     */
    TabEvaluate getEvaluateByOrderNumber(Integer enterpriseId, String orderNumber);
}
