package com.gic.evaluate.service;

import com.gic.evaluate.dto.ProblemMemberReplyDTO;
import com.gic.evaluate.dto.ProblemReplyDTO;
import com.gic.evaluate.dto.ProblemUserReplyDTO;

import java.util.List;
import java.util.Map;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 11:10
 */
public interface ProblemReplyService {
    /**
     * listReply
     * @Title: listReply
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return java.util.List<com.gic.evaluate.dto.ProblemReplyDTO>
     * @throws
     */
    List<ProblemReplyDTO> listReply(Integer problemId);

    /**
     * save
     * @Title: save
     * @Description:
     * @author zhiwj
     * @param problemUserReplyDTO
     * @return void
     * @throws
     */
    void save(ProblemUserReplyDTO problemUserReplyDTO);

    /**
     * save
     * @Title: save
     * @Description:
     * @author zhiwj
     * @param problemMemberReplyDTO
     * @return int
     * @throws
     */
    int save(ProblemMemberReplyDTO problemMemberReplyDTO);

    /**
     * update
     * @Title: update
     * @Description:
     * @author zhiwj
     * @param problemReplyDTO
     * @return void
     * @throws
     */
    void update(ProblemReplyDTO problemReplyDTO);

    /**
     * firstReplyByProblemId
     * @Title: firstReplyByProblemId
     * @Description:
     * @author zhiwj
     * @param problemIdList
     * @return java.util.Map<java.lang.Integer,java.lang.String>
     * @throws
     */
    Map<Integer, String> firstReplyByProblemId(List<Integer> problemIdList);
}
