package com.gic.evaluate.service;

import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.entity.TabProblem;
import com.gic.evaluate.qo.ProblemQO;
import com.github.pagehelper.Page;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 11:10
 */
public interface ProblemService {
    /**
     * listProblem
     * @Title: listProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return com.github.pagehelper.Page<com.gic.evaluate.entity.TabProblem>
     * @throws
     */
    Page<TabProblem> listProblem(ProblemQO problemQO);

    /**
     * getProblem
     * @Title: getProblem
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return com.gic.evaluate.entity.TabProblem
     * @throws
     */
    TabProblem getProblem(Integer problemId);

    /**
     * updateProblem
     * @Title: updateProblem
     * @Description:
     * @author zhiwj
     * @param problemDTO
     * @return void
     * @throws
     */
    void updateProblem(ProblemDTO problemDTO);

    /**
     * save
     * @Title: save
     * @Description:
     * @author zhiwj
     * @param problemDTO
     * @return java.lang.Integer
     * @throws
     */
    Integer save(ProblemDTO problemDTO);

    /**
     * listProblem
     * @Title: listProblem
     * @Description:
     * @author zhiwj
     * @param acuId
     * @return java.util.List<com.gic.evaluate.dto.ProblemDTO>
     * @throws
     */
    List<ProblemDTO> listProblem(Long acuId);

    /**
     * endProblem
     * @Title: endProblem
     * @Description:
     * @author zhiwj
     * @param problemId
     * @return void
     * @throws
     */
    void endProblem(Integer problemId);

    /**
     * countProblem
     * @Title: countProblem
     * @Description:
     * @author zhiwj
     * @param problemQO
     * @return java.lang.Integer
     * @throws
     */
    Integer countProblem(ProblemQO problemQO);

    /**
     * hasMaliciousStatusByAcuIdBeforeHours
     * @Title: hasMaliciousStatusByAcuIdBeforeHours
     * @Description:
     * @author zhiwj
     * @param acuId
     * @param badSuggestionTagType
     * @return boolean
     * @throws
     */
    boolean hasMaliciousStatusByAcuIdBeforeHours(Long acuId, Integer badSuggestionTagType);
}
