package com.gic.evaluate.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.constant.GreaterEnum;
import com.gic.evaluate.constant.LessEnum;
import com.gic.evaluate.dao.mapper.TabBadEvaluateConfigMapper;
import com.gic.evaluate.dto.BadEvaluateConfigDTO;
import com.gic.evaluate.entity.TabBadEvaluateConfig;
import com.gic.evaluate.service.BadEvaluateConfigService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-25 17:47
 */
@Service
public class BadEvaluateConfigServiceImpl implements BadEvaluateConfigService {

    @Autowired
    private TabBadEvaluateConfigMapper tabBadEvaluateConfigMapper;

    @Override
    public void init(Integer enterpriseId) {
        TabBadEvaluateConfig tabBadEvaluateConfig = new TabBadEvaluateConfig();
        tabBadEvaluateConfig.setEnterpriseId(enterpriseId);
        tabBadEvaluateConfig.setBadOnceStatus(Constants.OPEN);
        tabBadEvaluateConfig.setBadTotalStatus(Constants.CLOSE);
        tabBadEvaluateConfig.setBadGoodsType(LessEnum.LTE.getCode());
        tabBadEvaluateConfig.setBadGoodsScore(4);
        tabBadEvaluateConfig.setBadStoreType(LessEnum.LTE.getCode());
        tabBadEvaluateConfig.setBadStoreScore(4);
        tabBadEvaluateConfig.setBadServiceType(LessEnum.LTE.getCode());
        tabBadEvaluateConfig.setBadServiceScore(4);
        tabBadEvaluateConfig.setGoodStatus(Constants.OPEN);
        tabBadEvaluateConfig.setGoodOnceType(GreaterEnum.GTE.getCode());
        tabBadEvaluateConfig.setGoodOnceScore(8);
        tabBadEvaluateConfig.setGoodTotalType(GreaterEnum.GTE.getCode());
        tabBadEvaluateConfig.setGoodTotalScore(8);
        tabBadEvaluateConfig.setGoodNoReturn(Constants.OPEN);

        tabBadEvaluateConfigMapper.insertSelective(tabBadEvaluateConfig);
    }

    @Override
    public void updateBadEvaluateConfig(BadEvaluateConfigDTO badEvaluateConfigDTO) {
        TabBadEvaluateConfig badEvaluateConfig = EntityUtil.changeEntityByJSON(TabBadEvaluateConfig.class, badEvaluateConfigDTO);
        tabBadEvaluateConfigMapper.updateByPrimaryKeySelective(badEvaluateConfig);
    }

    @Override
    public TabBadEvaluateConfig getBadEvaluateConfig(Integer enterpriseId) {
        TabBadEvaluateConfig orderConfig = this.tabBadEvaluateConfigMapper.getBadEvaluateConfig(enterpriseId);
        if (orderConfig == null) {
            init(enterpriseId);
            return getBadEvaluateConfig(enterpriseId);
        }
        return orderConfig;
    }
}
