package com.gic.evaluate.service.impl;

import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.dao.mapper.TabEvaluateImgMapper;
import com.gic.evaluate.entity.TabEvaluateImg;
import com.gic.evaluate.service.EvaluateImgService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-15 10:20
 */
@Service
public class EvaluateImgServiceImpl implements EvaluateImgService {

    @Autowired
    private TabEvaluateImgMapper tabEvaluateImgMapper;

    @Override
    public List<TabEvaluateImg> listImageByEvaluateId(Integer evaluateId) {
        return tabEvaluateImgMapper.listImageByEvaluateId(evaluateId);
    }

    @Override
    public List<TabEvaluateImg> listImageByEvaluateReplyId(Integer evaluateReplyId) {
        return tabEvaluateImgMapper.listImageByEvaluateReplyId(evaluateReplyId);
    }

    @Override
    public void saveList(Integer enterpriseId, Integer problemId, List<String> imgUrlList) {
        this.saveList(enterpriseId, problemId, null, imgUrlList);
    }

    @Override
    public void saveList(Integer enterpriseId, Integer problemId, Integer problemReplyId, List<String> imgUrlList) {
        for (int i = 0; i < imgUrlList.size(); i++) {
            TabEvaluateImg tabProblemImg = new TabEvaluateImg();
            tabProblemImg.setEnterpriseId(enterpriseId);
            tabProblemImg.setEvaluateId(problemId);
            tabProblemImg.setEvaluateReplyId(problemReplyId);
            tabProblemImg.setSortNum(i);
            tabProblemImg.setImgUrl(imgUrlList.get(i));
            tabProblemImg.setStatus(Constants.OPEN);
            tabProblemImg.setCreateTime(new Date());
            tabEvaluateImgMapper.insertSelective(tabProblemImg);
        }
    }

}
