package com.gic.evaluate.service.impl;

import com.gic.enterprise.constants.Constants;
import com.gic.evaluate.constant.QuickReplyTypeEnum;
import com.gic.evaluate.dao.mapper.TabEvaluateQuickMapper;
import com.gic.evaluate.entity.TabEvaluateQuick;
import com.gic.evaluate.service.EvaluateQuickService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-30 11:07
 */
@Service
public class EvaluateQuickServiceImpl implements EvaluateQuickService {

    @Autowired
    private TabEvaluateQuickMapper tabEvaluateQuickMapper;

    @Override
    public void saveEvaluateQuick(Integer enterpriseId, List<String> evaluateQuick, Integer quickReplyType) {

        // 把所有的关联status设置为0
        tabEvaluateQuickMapper.delByEnterpriseId(enterpriseId, quickReplyType);
        if (CollectionUtils.isNotEmpty(evaluateQuick)) {
            // 插入不存在的关联
            for (String quick : evaluateQuick) {
                TabEvaluateQuick tabEvaluateQuick = new TabEvaluateQuick();
                tabEvaluateQuick.setTagType(quickReplyType);
                tabEvaluateQuick.setTagName(quick);
                tabEvaluateQuick.setCreateTime(new Date());
                tabEvaluateQuick.setEnterpriseId(enterpriseId);
                tabEvaluateQuick.setStatus(Constants.NORMAL_STATUS);
                tabEvaluateQuickMapper.insertSelectiveByNotExist(tabEvaluateQuick);
            }
            // 把所有userId关联status都设置为1
            tabEvaluateQuickMapper.updateStatusByEvaluateQuicks(enterpriseId, evaluateQuick, quickReplyType);
        }
    }

    @Override
    public List<TabEvaluateQuick> listEvaluateQuick(Integer enterpriseId, Integer quickReplyType) {
        return tabEvaluateQuickMapper.listEvaluateQuick(enterpriseId, quickReplyType);
    }

    @Override
    public TabEvaluateQuick getById(Integer quickTagsId) {
        return tabEvaluateQuickMapper.selectByPrimaryKey(quickTagsId);
    }

    @Override
    public List<Map<String, Object>> evaluateGoodQuickChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList) {
        return tabEvaluateQuickMapper.evaluateQuickChart(enterpriseId, startTime, endTime, QuickReplyTypeEnum.GOOD.getCode(), storeIdList);
    }

    @Override
    public List<Map<String, Object>> evaluateBadQuickChart(Integer enterpriseId, String startTime, String endTime, List<Integer> storeIdList) {
        return tabEvaluateQuickMapper.evaluateQuickChart(enterpriseId, startTime, endTime, QuickReplyTypeEnum.BAD.getCode(), storeIdList);
    }
}
