package com.gic.evaluate.service.impl;

import com.gic.enterprise.constants.Constants;
import com.gic.evaluate.constant.ReplyerTypeEnum;
import com.gic.evaluate.dao.mapper.TabEvaluateReplyMapper;
import com.gic.evaluate.dto.MemberReplyDTO;
import com.gic.evaluate.dto.UserReplyDTO;
import com.gic.evaluate.entity.TabEvaluateReply;
import com.gic.evaluate.service.EvaluateReplyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-27 9:54
 */
@Service
public class EvaluateReplyServiceImpl implements EvaluateReplyService {

    @Autowired
    private TabEvaluateReplyMapper tabEvaluateReplyMapper;

    @Override
    public List<TabEvaluateReply> listEvaluateReply(Integer enterpriseId, Integer evaluateId, Integer showStatus) {
        return tabEvaluateReplyMapper.listEvaluateReply(enterpriseId, evaluateId, showStatus);
    }

    @Override
    public Integer countReviewReplyByMember(Integer enterpriseId, Integer evaluateId) {
        return tabEvaluateReplyMapper.countReviewReplyByMember(enterpriseId, evaluateId);
    }

    @Override
    public Integer saveUserReplyEvaluate(UserReplyDTO userReplyDTO) {
        TabEvaluateReply tabEvaluateReply = new TabEvaluateReply();
        tabEvaluateReply.setEnterpriseId(userReplyDTO.getEnterpriseId());
        tabEvaluateReply.setEvaluateId(userReplyDTO.getEvaluateId());
        tabEvaluateReply.setReplyDate(new Date());
        tabEvaluateReply.setReplyerType(ReplyerTypeEnum.USER.getCode());
        tabEvaluateReply.setReplyContent(userReplyDTO.getReplyContent());
        tabEvaluateReply.setUserId(userReplyDTO.getUserId());
        tabEvaluateReply.setUserName(userReplyDTO.getUserName());
        tabEvaluateReply.setStatus(Constants.NORMAL_STATUS);
        tabEvaluateReply.setShowStatus(Constants.NORMAL_STATUS);
        tabEvaluateReply.setCreateTime(new Date());
        tabEvaluateReplyMapper.insertSelective(tabEvaluateReply);
        return tabEvaluateReply.getEvaluateReplyId();
    }

    @Override
    public Integer saveMemberReplyEvaluate(MemberReplyDTO memberReplyDTO) {
        TabEvaluateReply tabEvaluateReply = new TabEvaluateReply();
        tabEvaluateReply.setEnterpriseId(memberReplyDTO.getEnterpriseId());
        tabEvaluateReply.setEvaluateId(memberReplyDTO.getEvaluateId());
        tabEvaluateReply.setReplyDate(new Date());
        tabEvaluateReply.setReplyerType(ReplyerTypeEnum.MEMBER.getCode());
        tabEvaluateReply.setReplyContent(memberReplyDTO.getReplyContent());
        tabEvaluateReply.setMemberId(memberReplyDTO.getMemberId());
        tabEvaluateReply.setMemberName(memberReplyDTO.getMemberName());
        tabEvaluateReply.setMemberImgUrl(memberReplyDTO.getMemberImgUrl());
        tabEvaluateReply.setStatus(Constants.NORMAL_STATUS);
        tabEvaluateReply.setShowStatus(Constants.NORMAL_STATUS);
        tabEvaluateReply.setCreateTime(new Date());
        tabEvaluateReplyMapper.insertSelective(tabEvaluateReply);
        return tabEvaluateReply.getEvaluateReplyId();
    }

    @Override
    public void delReply(Integer evaluateReplyId) {
        TabEvaluateReply tabEvaluateReply = new TabEvaluateReply();
        tabEvaluateReply.setEvaluateReplyId(evaluateReplyId);
        tabEvaluateReply.setStatus(Constants.DEL_STATUS);
        tabEvaluateReplyMapper.updateByPrimaryKeySelective(tabEvaluateReply);
    }

    @Override
    public void updateReplyShowStatus(Integer enterpriseId, Integer evaluateReplyId, Integer showStatus) {
        tabEvaluateReplyMapper.updateReplyShowStatus(enterpriseId, evaluateReplyId, showStatus);
    }

    @Override
    public void update(UserReplyDTO userReplyDTO) {
        TabEvaluateReply tabEvaluateReply = new TabEvaluateReply();
        tabEvaluateReply.setEvaluateReplyId(userReplyDTO.getEvaluateReplyId());
        tabEvaluateReply.setReplyContent(userReplyDTO.getReplyContent());
        tabEvaluateReplyMapper.updateByPrimaryKeySelective(tabEvaluateReply);
    }
}
