package com.gic.evaluate.service.impl;

import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.dao.mapper.TabProblemImgMapper;
import com.gic.evaluate.entity.TabProblemImg;
import com.gic.evaluate.service.ProblemImgService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 11:35
 */
@Service
public class ProblemImgServiceImpl implements ProblemImgService {

    @Autowired
    private TabProblemImgMapper tabProblemImgMapper;

    @Override
    public List<TabProblemImg> listImageByProblemId(Integer problemId) {
        return tabProblemImgMapper.listImageByProblemId(problemId);
    }

    @Override
    public List<TabProblemImg> listImageByProblemReplyId(Integer problemReplyId) {
        return tabProblemImgMapper.listImageByProblemReplyId(problemReplyId);
    }

    @Override
    public void saveList(Integer enterpriseId, Integer problemId, List<String> imgUrlList) {
        this.saveList(enterpriseId, problemId, null, imgUrlList);
    }

    @Override
    public void saveList(Integer enterpriseId, Integer problemId, Integer problemReplyId, List<String> imgUrlList) {
        for (int i = 0; i < imgUrlList.size(); i++) {
            TabProblemImg tabProblemImg = new TabProblemImg();
            tabProblemImg.setEnterpriseId(enterpriseId);
            tabProblemImg.setProblemId(problemId);
            tabProblemImg.setProblemReplyId(problemReplyId);
            tabProblemImg.setSortNum(i);
            tabProblemImg.setImgUrl(imgUrlList.get(i));
            tabProblemImg.setStatus(Constants.OPEN);
            tabProblemImg.setCreateTime(new Date());
            tabProblemImgMapper.insertSelective(tabProblemImg);
        }
    }
}
