package com.gic.evaluate.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.download.utils.log.LogUtils;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.evaluate.dto.BadEvaluateConfigDTO;
import com.gic.evaluate.dto.EvaluateOrderConfigDTO;
import com.gic.evaluate.service.EvaluateConfigApiService;
import com.gic.evaluate.web.vo.BadEvaluateConfigVO;
import com.gic.evaluate.web.vo.BadTagConfigVO;
import com.gic.evaluate.web.vo.EvaluateOrderConfigVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-26 9:40
 */
@RestController
public class EvaluateOrderConfigController {

    @Autowired
    private EvaluateConfigApiService evaluateConfigApiService;

    @RequestMapping("/update-evaluate-order-config")
    public RestResponse updateEvaluateOrderConfig(EvaluateOrderConfigVO evaluateOrderConfigVO) {
        evaluateOrderConfigVO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Void> serviceResponse = evaluateConfigApiService.updateEvaluateOrderConfig(EntityUtil.changeEntityByJSON(EvaluateOrderConfigDTO.class, evaluateOrderConfigVO));
        LogUtils.createLog("修改订单评价机制", "订单评价机制");
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/update-bad-evaluate-config")
    public RestResponse updateBadEvaluateConfig(BadEvaluateConfigVO badEvaluateConfigVO) {
        badEvaluateConfigVO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Void> serviceResponse = evaluateConfigApiService.updateBadEvaluateConfig(EntityUtil.changeEntityByJSON(BadEvaluateConfigDTO.class, badEvaluateConfigVO));
        LogUtils.createLog("修改不良评价回访机制", "不良评价回访机制");
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/update-tag-config")
    public RestResponse updateBadTagConfig(BadTagConfigVO badTagConfigVO) {
        badTagConfigVO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Void> serviceResponse = evaluateConfigApiService.updateEvaluateOrderConfig(EntityUtil.changeEntityByJSON(EvaluateOrderConfigDTO.class, badTagConfigVO));
        LogUtils.createLog("修改投诉处理机制", "投诉处理机制");
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/get-evaluate-order-config")
    public RestResponse getEvaluateOrderConfig() {
        ServiceResponse<EvaluateOrderConfigDTO> serviceResponse = evaluateConfigApiService.getEvaluateOrderConfig(UserDetailUtils.getUserDetail().getEnterpriseId());
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/get-bad-evaluate-config")
    public RestResponse getBadEvaluateConfig() {
        ServiceResponse<BadEvaluateConfigDTO> serviceResponse = evaluateConfigApiService.getBadEvaluateConfig(UserDetailUtils.getUserDetail().getEnterpriseId());
        return ResultControllerUtils.commonResult(serviceResponse);
    }

}