package com.gic.evaluate.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.constant.ResourceHoldEnum;
import com.gic.auth.dto.OrderResourceDTO;
import com.gic.auth.service.ResourceApiService;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.evaluate.qo.StoreScoreQO;
import com.gic.evaluate.qo.StoreTrendQO;
import com.gic.evaluate.service.EvaluateOverviewApiService;
import com.gic.store.service.StoreWidgetApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-03 9:46
 */
@RestController
public class EvaluateOverviewController {

    @Autowired
    private EvaluateOverviewApiService evaluateOverviewApiService;
    @Autowired
    private StoreWidgetApiService storeWidgetApiService;
    @Autowired
    private ResourceApiService resourceApiService;

    @RequestMapping("/evaluate-chart1")
    public RestResponse evaluateChart1(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 权限判断
        // 判断权限
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }

        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        if (StringUtils.isNotBlank(startTime)) {
            startTime += " 00:00:00";
        }
        if (StringUtils.isNotBlank(endTime)) {
            endTime += " 23:59:59";
        }
        ServiceResponse<Map<String, Long>> serviceResponse = evaluateOverviewApiService.chart1(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart2")
    public RestResponse evaluateChart2(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 判断权限
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }

        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        if (StringUtils.isNotBlank(startTime)) {
            startTime += " 00:00:00";
        }
        if (StringUtils.isNotBlank(endTime)) {
            endTime += " 23:59:59";
        }
        ServiceResponse<HashMap<String, Map<String, Long>>> serviceResponse = evaluateOverviewApiService.chart2(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart3")
    public RestResponse evaluateChart3(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        if (StringUtils.isNotBlank(startTime)) {
            startTime += " 00:00:00";
        }
        if (StringUtils.isNotBlank(endTime)) {
            endTime += " 23:59:59";
        }
        ServiceResponse<Map<String, List<Map<String, Object>>>> serviceResponse = evaluateOverviewApiService.chart3(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart4")
    public RestResponse evaluateChart4(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }

        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        if (StringUtils.isNotBlank(startTime)) {
            startTime += " 00:00:00";
        }
        if (StringUtils.isNotBlank(endTime)) {
            endTime += " 23:59:59";
        }
        ServiceResponse<Map<String, List<Map<String, Object>>>> serviceResponse = evaluateOverviewApiService.chart4(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-store-score")
    public RestResponse evaluateStoreScore(StoreScoreQO storeScoreQO) {
        storeScoreQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeScoreQO.setStoreIdList(orderResourceDTO.getStoreIdList());
            }
        }

        if (StringUtils.isNotBlank(storeScoreQO.getStartTime())) {
            storeScoreQO.setStartTime(storeScoreQO.getStartTime() + " 00:00:00");
        }
        if (StringUtils.isNotBlank(storeScoreQO.getEndTime())) {
            storeScoreQO.setEndTime(storeScoreQO.getEndTime() + " 23:59:59");
        }
        ServiceResponse<Page<Map<String, Object>>> serviceResponse = evaluateOverviewApiService.listStoreScore(storeScoreQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-list-trend")
    public RestResponse evaluateListTrend(StoreTrendQO storeTrendQO) {
        storeTrendQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeTrendQO.setStoreIdList(orderResourceDTO.getStoreIdList());
            }
        }

        ServiceResponse<Page<Map<String, Object>>> serviceResponse = evaluateOverviewApiService.listTrend(storeTrendQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/good-trend-by-date")
    public RestResponse listGoodEvaluateTrendByDate(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }

        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<List<Map<String, Integer>>> serviceResponse = evaluateOverviewApiService.listGoodEvaluateTrendByDate(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/bad-trend-by-date")
    public RestResponse listBadEvaluateTrendByDate(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        // 权限判断
        OrderResourceDTO orderResourceDTO = resourceApiService.getOrderResourceByUserId(UserDetailUtils.getUserDetail().getUserId()).getResult();
        if (ResourceHoldEnum.DART.getCode().equals(orderResourceDTO.getType())) {
            if (CollectionUtils.isEmpty(orderResourceDTO.getStoreIdList())) {
                return RestResponse.success();
            } else {
                storeIdList = orderResourceDTO.getStoreIdList();
            }
        }
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        if (StringUtils.isNotBlank(startTime)) {
            startTime += " 00:00:00";
        }
        if (StringUtils.isNotBlank(endTime)) {
            endTime += " 23:59:59";
        }
        ServiceResponse<List<Map<String, Integer>>> serviceResponse = evaluateOverviewApiService.listBadEvaluateTrendByDate(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }
}
