package com.gic.evaluate.web.vo;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import java.io.Serializable;
import java.util.Date;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-12-26 10:23
 */
public class BadEvaluateConfigVO implements Serializable {
    private static final long serialVersionUID = 4482896683017528382L;

    public interface BadEvaluateValid{}

    /**
     *
     */
    private Integer badEvaluateConfigId;

    /**
     *
     */
    private Integer enterpriseId;

    /**
     * 任意一项到达设定值
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badOnceStatus;

    /**
     * 三项评价到达设定值
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badTotalStatus;

    private Integer badTotalType;

    private Integer badTotalScore;

    /**
     * 商品质量评分类型
     */
    @Min(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 3, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badGoodsType;

    /**
     * 商品质量评分
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badGoodsScore;

    /**
     * 门店环境评分类型
     */
    @Min(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 3, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badStoreType;

    /**
     * 门店环境评分
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badStoreScore;

    /**
     * 服务能力评分类型
     */
    @Min(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 3, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badServiceType;

    /**
     * 服务能力评分
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer badServiceScore;

    /**
     * 好评判定是否开启
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer goodStatus;

    /**
     * 好评判定 任何一项评价 类型
     */
    @Min(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 3, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer goodOnceType;

    /**
     * 好评任一评价分数
     */
    private Integer goodOnceScore;

    /**
     * 好评判定 全部评价 类型
     */
    @Min(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 3, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer goodTotalType;

    /**
     * 好评 全部评价 分数
     */
    private Integer goodTotalScore;

    /**
     * 好评无需回访
     */
    @Min(value = 0, message = "参数错误", groups = BadEvaluateValid.class)
    @Max(value = 1, message = "参数错误", groups = BadEvaluateValid.class)
    private Integer goodNoReturn;

    /**
     *
     */
    private Date updateTime;

    public Integer getBadEvaluateConfigId() {
        return badEvaluateConfigId;
    }

    public void setBadEvaluateConfigId(Integer badEvaluateConfigId) {
        this.badEvaluateConfigId = badEvaluateConfigId;
    }

    public Integer getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(Integer enterpriseId) {
        this.enterpriseId = enterpriseId;
    }

    public Integer getBadOnceStatus() {
        return badOnceStatus;
    }

    public void setBadOnceStatus(Integer badOnceStatus) {
        this.badOnceStatus = badOnceStatus;
    }

    public Integer getBadTotalStatus() {
        return badTotalStatus;
    }

    public void setBadTotalStatus(Integer badTotalStatus) {
        this.badTotalStatus = badTotalStatus;
    }

    public Integer getBadGoodsType() {
        return badGoodsType;
    }

    public void setBadGoodsType(Integer badGoodsType) {
        this.badGoodsType = badGoodsType;
    }

    public Integer getBadGoodsScore() {
        return badGoodsScore;
    }

    public void setBadGoodsScore(Integer badGoodsScore) {
        this.badGoodsScore = badGoodsScore;
    }

    public Integer getBadStoreType() {
        return badStoreType;
    }

    public void setBadStoreType(Integer badStoreType) {
        this.badStoreType = badStoreType;
    }

    public Integer getBadStoreScore() {
        return badStoreScore;
    }

    public void setBadStoreScore(Integer badStoreScore) {
        this.badStoreScore = badStoreScore;
    }

    public Integer getBadServiceType() {
        return badServiceType;
    }

    public void setBadServiceType(Integer badServiceType) {
        this.badServiceType = badServiceType;
    }

    public Integer getBadServiceScore() {
        return badServiceScore;
    }

    public void setBadServiceScore(Integer badServiceScore) {
        this.badServiceScore = badServiceScore;
    }

    public Integer getGoodStatus() {
        return goodStatus;
    }

    public void setGoodStatus(Integer goodStatus) {
        this.goodStatus = goodStatus;
    }

    public Integer getGoodOnceType() {
        return goodOnceType;
    }

    public void setGoodOnceType(Integer goodOnceType) {
        this.goodOnceType = goodOnceType;
    }

    public Integer getGoodOnceScore() {
        return goodOnceScore;
    }

    public void setGoodOnceScore(Integer goodOnceScore) {
        this.goodOnceScore = goodOnceScore;
    }

    public Integer getGoodNoReturn() {
        return goodNoReturn;
    }

    public void setGoodNoReturn(Integer goodNoReturn) {
        this.goodNoReturn = goodNoReturn;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getGoodTotalType() {
        return goodTotalType;
    }

    public void setGoodTotalType(Integer goodTotalType) {
        this.goodTotalType = goodTotalType;
    }

    public Integer getGoodTotalScore() {
        return goodTotalScore;
    }

    public void setGoodTotalScore(Integer goodTotalScore) {
        this.goodTotalScore = goodTotalScore;
    }

    public Integer getBadTotalType() {
        return badTotalType;
    }

    public void setBadTotalType(Integer badTotalType) {
        this.badTotalType = badTotalType;
    }

    public Integer getBadTotalScore() {
        return badTotalScore;
    }

    public void setBadTotalScore(Integer badTotalScore) {
        this.badTotalScore = badTotalScore;
    }
}
